/*** COPYRIGHT SECTION ******************************************************
* ( c ) COPYRIGHT 2007 - KONTRON CANADA INC. All rights reserved
* This software is confidential and proprietary to KONTRON CANADA
* KONTRON CANADA INC.
* 616 Cur�Boivin st., Boisbriand, CANADA
* J7G-2A7
****************************************************************************
*** DESCRIPTION SECTION ****************************************************
* File Name       :  readfile.c
* Creation Date   :  18-june-2007
* Programmer      :  Chanthy Toeung
* Description     :  A module to translate all the output files created 
*                    by the programme into a standard output ( print on screen )
***************************************************************************/
/*=========================================================================
* INCLUDES
*=========================================================================*/
#include <sys/time.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include "ipmipacket.h"

/*=========================================================================
* CONSTANTS
*=========================================================================*/

/*=========================================================================
* TYPEDEFS
*=========================================================================*/

/*=========================================================================
* MAIN PROGRAM
* complie by : readfile      pFileName
*=========================================================================*/
void hexdump_file ( char* fileNameIn, char* fileNameOut )
{
   FILE* pFileRead;
   int i, l;
   time_t curtime;
   char buffer[30];
   pFileRead = fopen( fileNameIn, "r" );
   if( pFileRead == NULL ){
      printf("can't open file %s\n", fileNameIn );
      return;
   }
   else{   
      tIpmb_Header   rqIpmbHeader;
      tIpmbPacket    rqPaquet;
      FILE* hexdumpFile;
      int k, j, pk;
      u08     offset;
      int numBytes = 0;
      pk = 0;
      hexdumpFile = fopen( fileNameOut, "w" );
      i = fread( &rqIpmbHeader, sizeof( rqIpmbHeader ), 1, pFileRead );
      i = fread( &rqPaquet, sizeof( rqPaquet ), 1, pFileRead );
      while( !feof( pFileRead ) ){
         pk++;
         if( ferror( pFileRead ) || ferror(hexdumpFile) ){
            perror("ERROR ");
            break;
         }
         /*Add Timestamp*/
         curtime = rqPaquet.waitTime.tv_sec;            
         strftime( buffer, 30, "%m/%d/%y %T.", localtime( &curtime ) );
         fprintf( hexdumpFile, "%s%ld\n", buffer, rqPaquet.waitTime.tv_usec );   	   	   
         /*group the byte of Netfn and LUN together*/
         rqIpmbHeader.netFn = (rqIpmbHeader.netFn << 2) + rqIpmbHeader.LUN ;
         rqPaquet.rqSeq = (rqPaquet.rqSeq << 2) + rqPaquet.LUN;
         /*calculate the data size*/
         numBytes = rqPaquet.data[0]-8;  /* packet size */
         /*write packet header to file*/
         if( numBytes > 0 )
            k = fprintf(hexdumpFile, "%08x  %02x", offset, numBytes);   	   
         if( numBytes <= 0 ){
               k = fprintf(hexdumpFile, "%08x  %02x %02x %02x  \n",
                        offset, rqPaquet.data[0]-1,
                        rqPaquet.data[numBytes+6], rqIpmbHeader.SlaveAdd);
         }
         else{
            k = fprintf(hexdumpFile, " %02x %02x %02x %02x %02x %02x %02x  \n",
                   rqPaquet.data[numBytes], rqIpmbHeader.SlaveAdd,
                   rqIpmbHeader.netFn, rqIpmbHeader.checkSum, rqPaquet.SlaveAdd,
                   rqPaquet.rqSeq, rqPaquet.cmd ); 
         
            l = 0;
            offset+= 8;
            k = fprintf(hexdumpFile, "%08x ", offset);
            for( j = 1; j < numBytes; j++){
               k = fprintf(hexdumpFile, " %02x", rqPaquet.data[j]);
               l++;
               if( (l == 8) && (j < (numBytes - 1) ) ){
                  fprintf(hexdumpFile, "  \n" );
                  offset += 8;         	
                  k = fprintf(hexdumpFile, "%08x ", offset);      	   
                  l = 0;
               }  	
            }
            fprintf(hexdumpFile, "  \n");
         }
         offset = 0;
         i = fread( &rqIpmbHeader, sizeof( rqIpmbHeader ), 1, pFileRead );
         i = fread( &rqPaquet, sizeof( rqPaquet ), 1, pFileRead );
      }
      fclose( hexdumpFile );
      printf("**** Output file name is : %s = %d packets *****\n", fileNameOut, pk);
      fclose( pFileRead );
	}
}
