/*** COPYRIGHT SECTION ******************************************************
* ( c ) COPYRIGHT 2007 - KONTRON CANADA INC. All rights reserved
* This software is confidential and proprietary to KONTRON CANADA
* KONTRON CANADA INC.
* 616 Cur�Boivin st., Boisbriand, CANADA
* J7G-2A7
****************************************************************************
*** DESCRIPTION SECTION ****************************************************
* File Name       :  readfile.c
* Creation Date   :  18-june-2007
* Programmer      :  Chanthy Toeung
* Description     :  A module to translate all the output files created 
*                    by the programme into a standard output ( print on screen )
***************************************************************************/
/*=========================================================================
* INCLUDES
*=========================================================================*/
#include <sys/time.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include "ipmipacket.h"

/*=========================================================================
* CONSTANTS
*=========================================================================*/

/*=========================================================================
* TYPEDEFS
*=========================================================================*/

/*=========================================================================
* MAIN PROGRAM
* complie by : readfile      pFileName
*=========================================================================*/
int main ( int argc, char *argv[] ) {
   char* pFileName;
   FILE* pFileRead;
   int i, l;
   struct timeval res;
   time_t curtime;
   char buffer[30];
   
   if ( argc<2 ){
      printf( "***Please specify the file name to be read.\n" );
      printf( "***usage : readfile FileName ... \n" );
   }
   else{
      pFileName = argv[1];
      printf( "%s\n", pFileName );
      pFileRead = fopen( pFileName, "r" );      
      /** try to read the data from file */
      if ( pFileRead == NULL ){
         printf( "error can't open the reading file\n" );
      }      
      else{
         printf( "start reading\n" );
		   u16 dataRead[DATA_SIZE];
		   int pk = 0;
         if( strcmp( pFileName, "rawData" ) == 0  ){
            while( !feof( pFileRead ) ){
               i = fread( &res, sizeof( res ), 1, pFileRead );
               curtime = res.tv_sec;            
               strftime( buffer, 30, "%m-%d-%y   %T.", localtime( &curtime ) );
               printf( "%s %ld ;%ld", buffer, curtime, res.tv_usec );
               i = fread( &dataRead, sizeof( dataRead ), 1, pFileRead );
               printf( "   [S]" );
               for ( l = 0; l< dataRead[0]; l++ ){
                  printf( "  %02x", dataRead[l] );
               }
               printf( "  [P]\n" );
               if( i != 0 )
                  pk++;
               
            }
            printf("pk = %d\n", pk);
         }
         else{
            tIpmb_Header   rqIpmbHeader;
            tIpmbPacket    rqPaquet;
            int pk = 0;
            while( !feof( pFileRead ) ){
               i = fread( &rqIpmbHeader, sizeof( rqIpmbHeader ), 1, pFileRead );
               i = fread( &rqPaquet, sizeof( rqPaquet ), 1, pFileRead );
               pk++;
               printf(" pk = %d\n", pk);
              
               if ( ftell( pFileRead ) == 8192 )
                  printf("ftell = 8k\n");
               curtime = rqPaquet.waitTime.tv_sec;            
               strftime( buffer, 30, "%m-%d-%y   %T.", localtime( &curtime ) );
               printf( "%s%f", buffer, rqPaquet.waitTime.tv_usec/1000000.0 );             
               printf( "   [S]" );
               printf( "  %02x  %02x  %02x  %02x || ", rqIpmbHeader.SlaveAdd,
                       rqIpmbHeader.netFn, rqIpmbHeader.LUN,
                       rqIpmbHeader.checkSum );
               printf( "  %02x  %02x  %02x  %02x \n data = ", rqPaquet.SlaveAdd,
                       rqPaquet.rqSeq, rqPaquet.LUN, rqPaquet.cmd );
               for ( l = 0; l< rqPaquet.data[0]-8; l++ ){
                  printf( "  %02x", rqPaquet.data[l] );
               }
               printf( "  \n\n" );
            }
         }
		   printf(":D");
         printf( "DONE\n" );
         fclose( pFileRead );
      }
	}
   return 0;
}
