/*** COPYRIGHT SECTION ****************************************************
* (c) COPYRIGHT 2007 - KONTRON CANADA INC. All rights reserved
* This software is confidential and proprietary to KONTRON CANADA
* KONTRON CANADA INC.
* 616 Cur�Boivin st., Boisbriand, CANADA
* J7G-2A7
***************************************************************************
*** DESCRIPTION SECTION ***************************************************
* File Name       :  sniff.h
* Creation Date   :  15-june-2007
* Programmer      :  Chanthy Toeung
* Description     :  The sniffer header module that containt the data 
*                 structure to communicate with Aardvark devices
**************************************************************************/
#ifndef SNIFF_H
#define SNIFF_H

#ifndef STDIN_FILENO
  #define STDIN_FILENO 0
#endif

/*=========================================================================
* INCLUDES
*=========================================================================*/
#include <sys/time.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <termios.h>
#include <unistd.h>
#include <errno.h>
#include "aardvark.h"

/*=========================================================================
* CONSTANTS
*=========================================================================*/
#define  BUFFER_SIZE          32767
#define  MESSAGE_SIZE         64
#define  INITIAL_TIMEOUT      5000
#define  INTERVAL_TIMEOUT     500
#define  MAX_AARDVARK_DEVICE  10
/*=========================================================================
* TYPEDEFS
*=========================================================================*/

/*=========================================================================
| GENERAL TYPE DEFINITIONS
 ========================================================================*/
extern int errno;
/*=========================================================================
* FUNCTIONS
*=========================================================================*/

void dumpSniff (
   Aardvark handle[MAX_AARDVARK_DEVICE],
   char* pFileName,
   int handleAmount
);

/*function for get key from keyboard*/
int set_tty_raw(void) ;

int set_tty_cbreak();

int set_tty_cooked();

unsigned char kb_getc(void) ;

unsigned char kb_getc_w(void) ;

#endif
